<?php

namespace App\Controller\Admin;

use App\Controller\AbstractAdminController;
use App\Entity\CollectifData\CollectifData;
use Lc\PietroBundle\Form\Dream\DreamType;
use Lc\PietroBundle\Form\ProjectBoost\ProjectBoostType;
use Lc\PietroBundle\Form\ProjectInspiring\ProjectInspiringType;
use Lc\PietroBundle\Form\Revolt\RevoltType;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\QueryBuilder;
use EasyCorp\Bundle\EasyAdminBundle\Collection\FieldCollection;
use EasyCorp\Bundle\EasyAdminBundle\Collection\FilterCollection;
use EasyCorp\Bundle\EasyAdminBundle\Dto\EntityDto;
use EasyCorp\Bundle\EasyAdminBundle\Dto\SearchDto;
use EasyCorp\Bundle\EasyAdminBundle\Field\AssociationField;
use EasyCorp\Bundle\EasyAdminBundle\Field\HiddenField;
use EasyCorp\Bundle\EasyAdminBundle\Field\IntegerField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use Lc\SovBundle\Field\CollectionField;
use Lc\SovBundle\Field\StatusField;
use Lc\SovBundle\Repository\RepositoryQueryInterface;

class CollectifDataCrudController extends AbstractAdminController
{
    public static function getEntityFqcn(): string
    {
        return CollectifData::class;
    }

    public function createEntity(string $entityFqcn)
    {
        return $this->getCollectifDataContainer()->getFactory()->create();
    }

    public function configureFields(string $pageName): iterable
    {
        return $this->getCollectifDataContainer()
            ->getFieldDefinition()
            ->getFields($pageName);
    }

    public function getRepositoryQuery(): RepositoryQueryInterface
    {
        return $this->getCollectifDataContainer()->getRepositoryQuery();
    }

    public function createIndexRepositoryQuery(
        SearchDto $searchDto,
        EntityDto $entityDto,
        FieldCollection $fields,
        FilterCollection $filters
    ): RepositoryQueryInterface {
        $repositoryQuery = parent::createIndexRepositoryQuery($searchDto, $entityDto, $fields, $filters);
        $status = $searchDto->getRequest()->get('status');
        if ($status || $status == 0) {
            $repositoryQuery->filterByStatus($searchDto->getRequest()->get('status'));
        }
        return $repositoryQuery;
    }

    public function persistEntity(EntityManagerInterface $entityManager, $entityInstance): void
    {
        $entityInstance->setUser($this->getUser());
        $entityManager->persist($entityInstance);
        $entityManager->flush();

        parent::persistEntity($entityManager, $entityInstance);
    }
}
